#!/bin/sh
# - belongs to /opt/scripts/bin
# - needs: tar, bzip2, gzip, bzcat, zcat, test, sh, md5sum, exit
# - should work on every unix!
# - version: 0.3
#
# what is it:
# ct    / ut   == normal
# ctv   / utv  == verbose
# creat / unpack an tar archiv
#

# samples:
# ct gz dir  ->  dir.tar.gz
# ct bz2 dir ->  dir.tar.bz2
# ut archiv.tar.bz2
# ut archiv.tar.gz

function error() {
 echo -en "\007"
 exit 1
}

B=`basename $0` # ct/ut
test "x$B" = "x" && error
test "x$1" = "x" && error

v=""
test "x$B" = "xutv" && v="-v"
test "x$B" = "xctv" && v="-v"

if [ "$B" == "ut" -o "$B" == "utv" ]; then 
 for i in $*; do
  test -r $i || continue
  G=`echo $i | grep -E 'gz$'` # gz + tgz
  [ "x$G" != "x" ] && CAT="zcat"
  G=`echo $i | grep -E 'bz2$'`
  [ "x$G" != "x" ] && CAT="bzcat"
  echo " -> $CAT $i | tar $v -x"
  $CAT $i | tar $v -x
 done
 exit 0
fi

if [ "$B" == "ct" -o "$B" == "ctv" ]; then
 test "$1" = "gz"  && PIPE="gzip -9"
 test "$1" = "bz2" && PIPE="bzip2 -9"
 test "x$PIPE" = "x"  && error
 E=$1 && shift
 for i in $*; do
  if [ ! -d $i ]; then
   echo " -> directory $i not found!"
   continue
  fi
  echo " -> tar $v -c $i | $PIPE > $i.tar.$E"
  tar $v -c $i | $PIPE > $i.tar.$E
  md5sum $i.tar.$E > $i.tar.$E.md5
 done
 exit 0
fi

error
